package bank;

import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.ReentrantLock;

public class Bank {

    Account[] accounts;
    ReentrantLock rlock=new ReentrantLock();
    Condition hasMoney=rlock.newCondition();
    
    public Bank(int n, int initial) {
	accounts=new Account[n];
	for(int i=0; i<n; i++){
	    accounts[i]=new Account(i, initial, this);
	}
	for(int i=0; i<n; i++){
	    accounts[i].start();
	}
    }
    
    //alternativa je synchronized void transfer(...)
    //onda nije potrebno koriscenje katanaca
    void transfer(int from, int to, int amount){
	rlock.lock();
	while(accounts[from].balance<amount)
	    try {
		hasMoney.await();
	    } catch (InterruptedException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	    }
	accounts[from].balance-=amount;
	accounts[to].balance+=amount;
	System.out.println("Racun #"+from+": "+accounts[from].balance);
	System.out.println("Ukupno: "+total());
	hasMoney.signalAll();
	rlock.unlock();
    }
    
    int total(){
	int sum=0;
	for(int i=0; i<accounts.length; i++){
	    sum+=accounts[i].balance;
	}
	return sum;
    }
    
    /**
     * @param args
     */
    public static void main(String[] args) {
	Bank bank=new Bank(100,100);
    }

    class Account extends Thread{
	int id;
	int balance;
	Bank bank;
	
	public Account(int id, int balance, Bank bank) {
	    this.id=id;
	    this.balance=balance;
	    this.bank=bank;
	}
	
	@Override
	public void run() {
	    super.run();
	    while(true){
		int from=id;
		int to=(int)(Math.random()*bank.accounts.length);
		int amount=(int) (Math.random()*50);
		bank.transfer(from, to, amount);
		try {
		    Thread.sleep(10);
		} catch (InterruptedException e) {
		    // TODO Auto-generated catch block
		    e.printStackTrace();
		}
	    }
	}
    }
    
}
